Subject: FITS "ambiguities"

From: egreisen at NRAO.EDU (Eric Greisen)
Date: Wed, 6 Dec 1995 10:08:51 -0500

Reply to:  kkuehl at ih4gp743.ih.att.com

Are you suggesting in your recent posting that all FITS keywords
should be required to have some sort of fixed format no matter what
they actually mean and require?  We thought long and hard about
requiring fixed format for ANY keywords and decided that the very
small number of required keywords - all logicals and modest integers -
would have a fixed format to help out stupid reading programs.  All
others are expected to follow Fortran free-format rules which are not
ambiguous at all.  There is no requirement that string keywords be of
length >= 8, there is a requirement that they follow Fortran rules.
Thus an embedded ' is represented as '' and the string data must be
surrounded by ' marks.  Earlier examples such as

     KEYWORD  =   0 1 a sample

are just erroneous.  If a comment is desired, it must be preceded by a
/ .  KEYWORD can be either a 1-valued or a 2-valued numeric parameter,
but it cannot be both a numeric and string array (violates Fortran
rules and was not listed as a possibility by us) and, besides, the
      a sample
above is not a Fortran string because it is not surrounded by quotes.

Why are we trying to invent ambiguities where there are none?

Eric Greisen, Scientist, NRAO

---

From: davis at space.mit.edu (John E. Davis)
Date: 9 Dec 1995 20:40:08 GMT

On Thu, 7 Dec 1995 15:07:12 GMT, Kevin Kuehl <kkuehl at ih4gp743.ih.att.com>
wrote:
 : But I think I have a better understanding of the intent of FITS
 : based on e-mail people have sent me.  Basically it sounds like FITS
 : is intended to have a human help the computer out and it is not
 : intended to be automatically readable like GIF or JPEG.

This is also the impression that I am getting.  I would like to regard a
fits file as a well-defined standalone object.  However, it seems to only be
well-defined within the context of a specific reader.  This is not what I
would call ``self-describing''.

-- 
John E. Davis                   Center for Space Research/AXAF Science Center
617-258-8119                    MIT 37-662c, Cambridge, MA 02139

---

From: kkuehl at ih4gp743.ih.att.com (Kevin Kuehl)
Date: Thu, 7 Dec 1995 15:07:12 GMT

In article <9512061508.AA25155 at primate.cv.nrao.edu>,
Eric Greisen <egreisen at NRAO.EDU> wrote:
>would have a fixed format to help out stupid reading programs.

What I am suggesting is that card images of the form 'keyword = value'
should have a "keyword" field that follows a set format and a "value"
field that follows a set format.  I was under the impression that
"value"s had to follow the definitions in the spec, but people have
said that if the "keyword" string is not predefined then whatever
is in the "value" area does not have to follow the definition.

But I think I have a better understanding of the intent of FITS
based on e-mail people have sent me.  Basically it sounds like FITS
is intended to have a human help the computer out and it is not
intended to be automatically readable like GIF or JPEG.
-- 
Kevin
kevin.r.kuehl at att.com

---

From: davis at space.mit.edu (John E. Davis)
Date: 8 Dec 1995 17:59:20 GMT

On 6 Dec 1995 10:10:20 -0500, Eric Greisen <egreisen at NRAO.EDU>
wrote:
 : surrounded by ' marks.  Earlier examples such as
 : 
 :      KEYWORD  =   0 1 a sample
 : 
 : are just erroneous.  If a comment is desired, it must be preceded by a
                                                    ^^^^ 
 : / .  KEYWORD can be either a 1-valued or a 2-valued numeric parameter,
 
The fact is that the fits definition paper does NOT require a / to start a
comment.  This is the source of one ambiguity.